← All operations
PUT/api/v1/agents/{entityPublicId}/cards/{cardPublicId}/policy

Cards_UpdateCardPolicy

Authentication
required-user
Cache policy
none
Success and errors
200, 400, 401, 403, 404, 409, 422, 500
Stability
v1 stable contract

OpenAPI operation

{
  "operationId": "Cards_UpdateCardPolicy",
  "summary": "PUT /api/v1/agents/{entityPublicId}/cards/{cardPublicId}/policy",
  "tags": [
    "Cards"
  ],
  "parameters": [
    {
      "name": "entityPublicId",
      "in": "path",
      "required": true,
      "schema": {
        "type": "string",
        "format": "uuid",
        "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
      }
    },
    {
      "name": "cardPublicId",
      "in": "path",
      "required": true,
      "schema": {
        "type": "string",
        "format": "uuid",
        "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
      }
    },
    {
      "name": "Idempotency-Key",
      "in": "header",
      "required": true,
      "schema": {
        "type": "string",
        "format": "uuid"
      }
    }
  ],
  "requestBody": {
    "required": true,
    "content": {
      "application/json": {
        "schema": {
          "type": "object",
          "properties": {
            "currency": {
              "type": "string",
              "minLength": 3,
              "maxLength": 3
            },
            "perAuthorizationMaximumMinor": {
              "type": "string",
              "pattern": "^[1-9][0-9]{0,77}$"
            },
            "dailyMaximumMinor": {
              "type": "string",
              "pattern": "^[1-9][0-9]{0,77}$"
            },
            "weeklyMaximumMinor": {
              "type": "string",
              "pattern": "^[1-9][0-9]{0,77}$"
            },
            "monthlyMaximumMinor": {
              "type": "string",
              "pattern": "^[1-9][0-9]{0,77}$"
            },
            "agentBudgetMinor": {
              "anyOf": [
                {
                  "type": "string",
                  "pattern": "^[1-9][0-9]{0,77}$"
                },
                {
                  "type": "null"
                }
              ]
            },
            "accountBudgetMinor": {
              "anyOf": [
                {
                  "type": "string",
                  "pattern": "^[1-9][0-9]{0,77}$"
                },
                {
                  "type": "null"
                }
              ]
            },
            "merchantRules": {
              "default": {
                "allow": [],
                "deny": []
              },
              "type": "object",
              "properties": {
                "allow": {
                  "default": [],
                  "maxItems": 500,
                  "type": "array",
                  "items": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 200
                  }
                },
                "deny": {
                  "default": [],
                  "maxItems": 500,
                  "type": "array",
                  "items": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 200
                  }
                }
              },
              "additionalProperties": false
            },
            "merchantCategoryRules": {
              "default": {
                "allow": [],
                "deny": []
              },
              "type": "object",
              "properties": {
                "allow": {
                  "default": [],
                  "maxItems": 500,
                  "type": "array",
                  "items": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 200
                  }
                },
                "deny": {
                  "default": [],
                  "maxItems": 500,
                  "type": "array",
                  "items": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 200
                  }
                }
              },
              "additionalProperties": false
            },
            "countryRules": {
              "default": {
                "allow": [],
                "deny": []
              },
              "type": "object",
              "properties": {
                "allow": {
                  "default": [],
                  "maxItems": 500,
                  "type": "array",
                  "items": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 200
                  }
                },
                "deny": {
                  "default": [],
                  "maxItems": 500,
                  "type": "array",
                  "items": {
                    "type": "string",
                    "minLength": 1,
                    "maxLength": 200
                  }
                }
              },
              "additionalProperties": false
            },
            "cardPresentAllowed": {
              "default": false,
              "type": "boolean"
            },
            "onlineOnly": {
              "default": true,
              "type": "boolean"
            },
            "recurringAllowed": {
              "default": false,
              "type": "boolean"
            },
            "allowedCurrencies": {
              "minItems": 1,
              "maxItems": 20,
              "type": "array",
              "items": {
                "type": "string",
                "minLength": 3,
                "maxLength": 3
              }
            },
            "velocityRules": {
              "default": {},
              "type": "object",
              "propertyNames": {
                "type": "string"
              },
              "additionalProperties": {}
            },
            "riskTier": {
              "type": "string",
              "enum": [
                "LOW",
                "MODERATE",
                "HIGH",
                "VERY_HIGH",
                "UNKNOWN"
              ]
            },
            "approvalThresholdMinor": {
              "anyOf": [
                {
                  "type": "string",
                  "pattern": "^[1-9][0-9]{0,77}$"
                },
                {
                  "type": "null"
                }
              ]
            }
          },
          "required": [
            "currency",
            "perAuthorizationMaximumMinor",
            "dailyMaximumMinor",
            "weeklyMaximumMinor",
            "monthlyMaximumMinor",
            "allowedCurrencies",
            "riskTier"
          ],
          "additionalProperties": false
        }
      }
    }
  },
  "security": [
    {
      "cookieAuth": []
    }
  ],
  "responses": {
    "200": {
      "description": "Success",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "additionalProperties": false,
            "required": [
              "data",
              "meta"
            ],
            "properties": {
              "data": {
                "type": "object",
                "properties": {
                  "version": {
                    "type": "integer",
                    "exclusiveMinimum": 0,
                    "maximum": 9007199254740991
                  },
                  "state": {
                    "type": "string"
                  },
                  "currency": {
                    "type": "string"
                  },
                  "perAuthorizationMaximumMinor": {
                    "type": "string"
                  },
                  "dailyMaximumMinor": {
                    "type": "string"
                  },
                  "weeklyMaximumMinor": {
                    "type": "string"
                  },
                  "monthlyMaximumMinor": {
                    "type": "string"
                  },
                  "agentBudgetMinor": {
                    "anyOf": [
                      {
                        "type": "string"
                      },
                      {
                        "type": "null"
                      }
                    ]
                  },
                  "accountBudgetMinor": {
                    "anyOf": [
                      {
                        "type": "string"
                      },
                      {
                        "type": "null"
                      }
                    ]
                  },
                  "merchantRules": {},
                  "merchantCategoryRules": {},
                  "countryRules": {},
                  "cardPresentAllowed": {
                    "type": "boolean"
                  },
                  "onlineOnly": {
                    "type": "boolean"
                  },
                  "recurringAllowed": {
                    "type": "boolean"
                  },
                  "allowedCurrencies": {
                    "type": "array",
                    "items": {
                      "type": "string"
                    }
                  },
                  "velocityRules": {},
                  "riskTier": {
                    "type": "string"
                  },
                  "approvalThresholdMinor": {
                    "anyOf": [
                      {
                        "type": "string"
                      },
                      {
                        "type": "null"
                      }
                    ]
                  },
                  "policyDigest": {
                    "type": "string"
                  }
                },
                "required": [
                  "version",
                  "state",
                  "currency",
                  "perAuthorizationMaximumMinor",
                  "dailyMaximumMinor",
                  "weeklyMaximumMinor",
                  "monthlyMaximumMinor",
                  "agentBudgetMinor",
                  "accountBudgetMinor",
                  "merchantRules",
                  "merchantCategoryRules",
                  "countryRules",
                  "cardPresentAllowed",
                  "onlineOnly",
                  "recurringAllowed",
                  "allowedCurrencies",
                  "velocityRules",
                  "riskTier",
                  "approvalThresholdMinor",
                  "policyDigest"
                ],
                "additionalProperties": false
              },
              "meta": {
                "type": "object",
                "additionalProperties": true,
                "required": [
                  "requestId",
                  "schemaVersion",
                  "buildVersion",
                  "generatedAt",
                  "freshness"
                ],
                "properties": {
                  "requestId": {
                    "type": "string",
                    "format": "uuid"
                  },
                  "schemaVersion": {
                    "type": "string"
                  },
                  "buildVersion": {
                    "type": "string"
                  },
                  "generatedAt": {
                    "type": "string",
                    "format": "date-time"
                  },
                  "freshness": {
                    "type": "object",
                    "additionalProperties": false,
                    "required": [
                      "projectedAt",
                      "sourceWatermark"
                    ],
                    "properties": {
                      "projectedAt": {
                        "type": [
                          "string",
                          "null"
                        ],
                        "format": "date-time"
                      },
                      "sourceWatermark": {
                        "type": [
                          "string",
                          "null"
                        ]
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    },
    "400": {
      "description": "invalid request",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "401": {
      "description": "unauthenticated",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "403": {
      "description": "forbidden",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "404": {
      "description": "not found",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "409": {
      "description": "conflict",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "422": {
      "description": "configuration missing",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    },
    "500": {
      "description": "internal error",
      "content": {
        "application/problem+json": {
          "schema": {
            "$ref": "#/components/schemas/ApiError"
          }
        }
      }
    }
  },
  "x-auth-mode": "required-user",
  "x-cache-policy": "none",
  "x-required-scopes": [],
  "x-rate-cost": 1,
  "x-stability": "STABLE"
}